#!/bin/bash

# This sript retrieve information from log file
# from a JM-Contact string, from a CE point of view

TMP=`mktemp -q`

JM=$1
CALL=$2

LOG_DIR=`/bin/grep -v -e \# /etc/lcg-logs.conf | /bin/grep log_dir | sed -u -e 's/.*=//g'| sed -u -e 's/\s//g'`
MYSQL_U=`/bin/grep -v -e \# /etc/lcg-logs.conf | /bin/grep mysql_user | sed -u -e 's/.*=//g'| sed -u -e 's/\s//g'`
MYSQL_P=`/bin/grep -v -e \# /etc/lcg-logs.conf | /bin/grep mysql_password | sed -u -e 's/.*=//g' | sed -u -e 's/\s//g'`
MYSQL_D=`/bin/grep -v -e \# /etc/lcg-logs.conf | /bin/grep mysql_db | sed -u -e 's/.*=//g'| sed -u -e 's/\s//g'`

# Gatekeeper data

#JM1=`echo ${JM}|awk -F ":" '{print $3}'|awk -F "/" '{print $3}'`
#JM2=`echo ${JM}|awk -F ":" '{print $3}'|awk -F "/" '{print $2}'`
#CE=`echo ${JM} |awk -F "/" '{print $3}'|awk -F ":" '{print $1}'`
JM1=`echo ${JM}|awk -F "." '{print $1}'`
JM2=`echo ${JM}|awk -F "." '{print $2}'`
CE=`echo ${JM}|awk -F "." '{print $3}'`
TIME=`date`

echo "####################################################################"
echo "${TIME}: Tracing GRAM_SCRIPT_JOB_ID: ${JM1}.${JM2} on ${CE}"
echo "####################################################################"


GK=`grep -e ${JM1} ${LOG_DIR}* | grep -e ${JM2}| grep "GATEKEEPER_JM_ID" `
EXIT="0"


# GK should look like:
# /data/log/daemon.log:Dec 13 06:44:26 lxb2018 gridinfo[30103]: JMA 2005/12/13 06:44:26 GATEKEEPER_JM_ID 2005-12-13.06:44:19.0000002127.0000005592 has GRAM_SCRIPT_JOB_ID 1134452666:lcgpbs:internal_4089785042:30103.1134452664 manager type lcgpbs

GATEKEEPER_JM_ID=`echo ${GK} | sed -e 's/.*GATEKEEPER_JM_ID \(.*\)/\1/g'|sed -e 's/ has .*//g'`

if [ "x$GATEKEEPER_JM_ID" == "x" ]; then
	echo "GATEKEEPER_JM_ID not available"
	EXIT="1"
fi

GRAM_SCRIPT_JOB_ID=`echo ${GK} | sed -e 's/.* GRAM_SCRIPT_JOB_ID \(.*\)/\1/g'|sed -e 's/ manager .*//g'`

if [ "x$GRAM_SCRIPT_JOB_ID" == "x" ]; then
        echo "GRAM_SCRIPT_JOB_ID not available"
        EXIT="1"
fi

if [ "$EXIT" == "1" ]; then
	echo "Information is missing for CE ${CE}"
else

# Retrieving the GK information

	GKJMID=`grep -e "${GATEKEEPER_JM_ID}" ${LOG_DIR}* > ${TMP}`
	GK_REF=`cat ${TMP} |awk -F":" '{print $2 ":" $3 ":" $4}'|sort -u`
	CE_UID=`cat ${TMP}|grep "mapped to"| sed -e 's/.*mapped to \(.*\)$/\1/g'`
	DN=`cat ${TMP}|grep " for " |sed -e 's/.* for \(.*\)/\1/g'|sed -e 's/ on .*//g'`
	UI=`cat ${TMP}|grep " for " |sed -e 's/.* on \(.*\)/\1/g'`
	UI_FQDN=`echo ${UI}|xargs host |awk '{print $5}'`

	echo "--"
	echo "Source:"
	echo "${GK_REF}"
	echo "* CE User ID: ${CE_UID}"
	echo "* User DN:${DN}"
	echo "* Submitted from RB or UI ${UI} (${UI_FQDN})"
	echo "* GATEKEEPER_JM_ID: ${GATEKEEPER_JM_ID}"
	echo "* GRAM_SCRIPT_JOB_ID: ${GRAM_SCRIPT_JOB_ID}"


# Checking if a similar entry already exists

	SQL="select count(*) from job where JM1='${JM1}' and JM2='${JM2}' and CE='${CE}';"
	RES=`mysql -u ${MYSQL_U} -p${MYSQL_P} ${MYSQL_D} -B -e "${SQL}" |grep -v "count"`
	echo ${RES}

	if [ "$RES" != "0" ]; then
		# Updating similar entry
		echo "Existing entry: updating database..."
		SQL="update job set JM1='${JM1}'"
		if [ "x${CE}" != "x" ]; then SQL=${SQL}",CE='${CE}'";fi
		if [ "x${CE_UID}" != "x" ]; then SQL=${SQL}",CE_UID='${CE_UID}'";fi
                if [ "x${CE_DN}" != "x" ]; then SQL=${SQL}",CE_DN='${CE_DN}'";fi
                if [ "x${UI}" != "x" ]; then SQL=${SQL}",UI='${UI}'";fi
                if [ "x${UI_FQDN}" != "x" ]; then SQL=${SQL}",UI_FQDN='${UI_FQDN}'";fi
                if [ "x${GATEKEEPER_JM_ID}" != "x" ]; then SQL=${SQL}",GATEKEEPER_JM_ID='${GATEKEEPER_JM_ID}'";fi
                if [ "x${GRAM_SCRIPT_JOB_ID}" != "x" ]; then SQL=${SQL}",GRAM_SCRIPT_JOB_ID='${GRAM_SCRIPT_JOB_ID}'";fi

		SQL=${SQL}" where JM1='${JM1}' and JM2='${JM2} and CE='${CE}';"
                RES=`mysql -u ${MYSQL_U} -p${MYSQL_P} ${MYSQL_D} -B -e "${SQL}"`
                echo ${RES}

	else
		echo "New entry: adding to database..."
		SQL="insert into job set JM1='${JM1}',JM2='${JM2}',CE='${CE}',CE_UID='${CE_UID}',CE_DN='${DN}',UI='${UI}',UI_FQDN='${UI_FQDN}',GATEKEEPER_JM_ID='${GATEKEEPER_JM_ID}',GRAM_SCRIPT_JOB_ID='${GRAM_SCRIPT_JOB_ID}'"
		RES=`mysql -u ${MYSQL_U} -p${MYSQL_P} ${MYSQL_D} -B -e "${SQL}"`
		echo ${RES}
	fi

fi

rm -f ${TMP}

#if [ "$CALL" != "scan_RB" ]; then
#
#	echo "--"
#	echo "Retrieving information from the RB"
#	echo "--"
#	/usr/bin/scan_RB.sh ${JM} scan_CE
#
#fi
